︠7857d063-026b-443b-a955-fefd9d178138s︠
#3.1
# bandpass signal x(t)
# and its magnitude spectrum
import numpy as np
from scipy.fftpack import fft, ifft
f0=200 #center freq
duration = 4.0
fs = 1000.0 # number of samples/duration
samples = int(fs*duration)
t = -2+np.arange(samples)/fs #arange is used to construct array [0...samples-1]
x = (np.sinc(100*t))*np.cos(2*np.pi*f0*t) # discrete bandpass signal
lt=np.array(t).tolist() #convert array t to list
lx=np.array(x).tolist() #convert array x to list
Px=list_plot(zip(lt,lx),plotjoined=true,figsize=(5,3),xmin=-0.2,xmax=0.2)
P1=text("t",(0.2,-0.2))
P2=text("$x(t)=\sinc(100t)\cos(400\pi t$)",(0.1,1))
show(Px+P1+P2)
Fx=np.fft.fft(x) # Fast Fourier Transform
f=np.fft.fftfreq(len(t),1/fs) #Compute Discrete Fourier Transform sample frequencies
magx=np.abs(Fx)
lmagx=np.array(magx).tolist()
lf=np.array(f).tolist()
Mx=list_plot((zip(lf,lmagx)),plotjoined=true,figsize=(5,3),xmin=-550,xmax=550)
M1=text("f",(600,-0.2))
M2=text("$|X(f)|=\Pi((f-f0)/100)+\Pi((f+f0)/100)$)",(300,5.5))
show(Mx+M1+M2)
︡e78e2cd9-4c87-4e20-8159-59be2673b396︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/111/tmp_BzBP9D.svg","show":true,"text":null,"uuid":"7db48fea-bcf0-42eb-b808-ec431aea9f47"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/111/tmp_Z3ekX6.svg","show":true,"text":null,"uuid":"5ff06051-f41f-48f2-82db-4c3d1ae27bb1"},"once":false}︡{"done":true}︡
︠24befdf3-9769-46ac-867d-622677dd63bds︠
#3.2
reset()
import numpy as np
from scipy.fftpack import fft, ifft
f0=200 #center freq
duration = 4.0
fs = 1000.0 # number of samples/duration
samples = int(fs*duration)
t = -2+np.arange(samples)/fs #arange is used to construct array [0...samples-1]
x = (np.sinc(100*t)) # discrete lowpass signal
lt=np.array(t).tolist() #convert array t to list
lx=np.array(x).tolist() #convert array x to list
Px=list_plot(zip(lt,lx),plotjoined=true,figsize=(5,3),xmin=-0.2,xmax=0.2)
P1=text("t",(0.2,-0.2))
P2=text("$x_l(t)=\sinc(100t)$)",(0.1,1))
show(Px+P1+P2)
Fx=np.fft.fft(x) # Fast Fourier Transform
f=np.fft.fftfreq(len(t),1/fs) #Compute Discrete Fourier Transform sample frequencies
magx=np.abs(Fx)
lmagx=np.array(magx).tolist()
lf=np.array(f).tolist()
Mx=list_plot((zip(lf,lmagx)),plotjoined=true,figsize=(5,3),xmin=-550,xmax=550)
M1=text("f",(600,-0.2))
M2=text("$|X_l(f)|=\Pi(f/100)$)",(300,12.5))
show(Mx+M1+M2)
︡5cf53bae-73a0-4e85-808d-a11a36dfb0e5︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/111/tmp_BPUWGG.svg","show":true,"text":null,"uuid":"e322178d-e2a4-41af-b1b3-9bef53263231"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/111/tmp_B4jXvE.svg","show":true,"text":null,"uuid":"27d65b54-1ac7-4fbe-b452-63fb34e8f9b3"},"once":false}︡{"done":true}︡
︠42160112-c227-4f58-a595-0fa845ca469as︠
#3.3
# Returns the lowpass equivalent of the signal x
# f0 is the center frequency
reset()
def loweq(x,t,f0):
    z=hilbert(x) # compute analytic signal, z(t)=x(t)+ix^(t)
    xl=z*np.exp(-i*2*pi*f0*t)
    return xl
︡7d9dceb1-cd42-46d2-8669-3a7d65ff3e35︡{"done":true}︡
︠9058d72f-ff5b-4f16-a50e-93b041eb163as︠
#3.3
# lowpass signal xl(t) by numerical computation
# and its magnitude spectrum
import numpy as np
import matplotlib.pyplot as plt
from scipy.signal import hilbert, chirp
from scipy.fftpack import fft, ifft
f0=200 #center freq
duration = 4.0
fs = 1000.0 # number of samples/duration
samples = int(fs*duration)
t = -2+np.arange(samples)/fs #arange is used to construct array [0...samples-1]
x = (np.sinc(100*t))*np.cos(2*np.pi*f0*t) # discrete bandpass signal
xl=loweq(x,t,f0)
Fx=np.fft.fft(xl) # Fast Fourier Transform
f=np.fft.fftfreq(len(t),1/fs) #Compute Discrete Fourier Transform sample frequencies
magx=np.abs(Fx)
lmagx=np.array(magx).tolist()
lf=np.array(f).tolist()
Mx=list_plot((zip(lf,lmagx)),plotjoined=true,figsize=(5,3),xmin=-550,xmax=550)
M1=text("f",(600,-0.2))
M2=text("$|X_l(f)|=\Pi(f/100)$)",(300,12.5))
show(Mx+M1+M2)
︡01625dcc-a12c-4ea0-aa03-745c4a08e907︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/111/tmp_62N2e3.svg","show":true,"text":null,"uuid":"7c000bf1-4898-4c48-acc0-159ccaa71e6d"},"once":false}︡{"done":true}︡
︠66a0f7a2-a03f-4b9f-963e-680cf77e8cabs︠
#3.4
# In-phase component x_s(t) of x_l(t) and envelope V(t) of x(t)
# by analytic
# Returns the lowpass equivalent of the signal x
# f0 is the center frequency
reset()
import numpy as np
import matplotlib.pyplot as plt
from scipy.signal import hilbert, chirp
from scipy.fftpack import fft, ifft
f0=200 #center freq
duration = 4.0
fs = 1000.0 # number of samples/duration
samples = int(fs*duration)
t = -2+np.arange(samples)/fs #arange is used to construct array [0...samples-1]
xl = np.sinc(100*t) # discrete lowpass signal
xc=xl # discrete inphase component of lowpass signal
v=np.abs(xc) # discrete envelope of signal x(t)
lxc=np.array(xc).tolist()
lt=np.array(t).tolist()
lv=np.array(v).tolist()
Pxc=list_plot((zip(lt,lxc)),plotjoined=true,figsize=(5,3),xmin=-0.2,xmax=0.2)
P1=text("t",(0.2,-0.2))
P2=text("$x_c(t)=\sinc(100t)$)",(0.1,1))
show(Pxc+P1+P2)
Mv=list_plot((zip(lt,lv)),plotjoined=true,figsize=(5,3),xmin=-0.2,xmax=0.2)
M1=text("t",(0.2,-0.2))
M2=text("$V(t)=|\sinc(100t)|$",(0.1,1))
show(Mv+M1+M2)
︡0501d09f-66f0-424a-aedc-cf26ed948c65︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/111/tmp_lbqQxg.svg","show":true,"text":null,"uuid":"78b77a5b-cddc-4a6c-bef5-611fd22f9e1b"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/111/tmp_BCQuhM.svg","show":true,"text":null,"uuid":"84fc84ce-88ad-4498-a37f-ade2bf0947a1"},"once":false}︡{"done":true}︡
︠445bd4a3-d017-49e2-bfb7-7be26559a6ce︠









